<template>
    <div
        class="toolbar"
        v-if="RulesStore.hasChanges || RulesStore.saved || TestsStore.testsAreChecking || TestsStore.apiErrors"
    >
        <el-alert
            v-if="RulesStore.hasChanges"
            title="Правила не опубликованы."
            type="warning"
            show-icon
            :closable="false"
        />
        <el-alert v-if="RulesStore.saved" title="Правила опубликованы." type="success" show-icon />
        <el-alert
            v-if="TestsStore.testsAreChecking"
            title="Тесты проверяются ..."
            type="info"
            show-icon
            :closable="false"
            style="position: sticky; top: 20px"
        />
        <el-alert
            v-if="TestsStore.apiErrors && !TestsStore.testsAreChecking"
            :title="'Не удалось проверить тесты: ' + TestsStore.apiErrors.error"
            type="error"
            show-icon
            @close="TestsStore.apiErrors = false"
        />
        <div class="el-alert" v-if="RulesStore.hasChanges" style="background: transparent">
            <div class="el-alert__content">
                <el-button @click="TestsStore.execTests()" class="is_first"> Выполнить тесты </el-button>
                <el-button
                    @click="
                        () => {
                            RulesStore.resetRules();
                            TestsStore.execTests();
                        }
                    "
                >
                    Сбросить изменения
                </el-button>
                <el-button
                    type="primary"
                    @click="
                        () => {
                            RulesStore.saveRules();
                            TestsStore.execTests();
                        }
                    "
                >
                    Опубликовать
                </el-button>
            </div>
        </div>
    </div>
</template>

<script>
import { useParseRulesStore } from "@/js/stores/RulesStore";
import { useParseTestsStore } from "@/js/stores/TestsStore";
import { useProductTypeStore } from "@/js/stores/ProductTypeStore";
import { useLocalStorage } from "@vueuse/core";

export default {
    props: {
        rules: Object,
        tests: Object,
    },
    setup(props) {
        const RulesStore = useParseRulesStore();
        const TestsStore = useParseTestsStore();
        const ProductTypeStore = useProductTypeStore();

        ProductTypeStore.$subscribe(() => {
            RulesStore.productType = ProductTypeStore.type;
            RulesStore.rules = useLocalStorage("pinia/rules/" + ProductTypeStore.type, []);
            //loadRules();
        });

        function loadRules() {
            RulesStore.initialRules = props.rules;
            if (RulesStore.rules.length === 0) RulesStore.rules = JSON.parse(JSON.stringify(RulesStore.initialRules));

            TestsStore.tests = props.tests;
            TestsStore.errors = [];
            if (TestsStore.errors.length === 0) TestsStore.execTests();
        }

        loadRules();

        return {
            RulesStore,
            TestsStore,
        };
    },
    data() {
        return {
            saved: false,
            testsAreChecking: false,
        };
    },
    computed: {
        hasUnsaved() {
            return this.RulesStore.rulesCount > 0;
        },
    },
};
</script>

<style lang="scss" scoped>
.toolbar {
    width: 100%;
    position: sticky;
    height: 48px;
    top: 1em;
    z-index: 5;
}
.el-alert {
    position: absolute;
    top: 0;
    min-height: 48px;
}
.el-alert__content {
    display: flex;
    align-items: center;
    width: 100%;
}
.el-button.is_first {
    margin-left: auto;
}
</style>
